#include <avr/io.h>
#include "peri.h"

void init_keypad()
{
//set to output
	DDRC |= (1<<PC0) | (1<<PC1) | (1<<PC2) | (1<<PC3) | (1<<PC4) | (1<<PC5);
	DDRB |= (1<<PB4) | (1<<PB5);
//set to LOW
	PORTC &= ~(1<<PC0) & ~(1<<PC1) & ~(1<<PC2) & ~(1<<PC3) & ~(1<<PC4) & ~(1<<PC5);
	PORTB &= ~(1<<PB4) & ~(1<<PB5);
//set input
	DDRB &= ~(1<<PB0) & ~(1<<PB1) & ~(1<<PB2) & ~(1<<PB3);
	DDRD &= ~(1<<PD0) & ~(1<<PD1) & ~(1<<PD5) & ~(1<<PD6);
//set pullup
	PORTB |= (1<<PB0) | (1<<PB1) | (1<<PB2) | (1<<PB3);
	PORTD |= (1<<PD0) | (1<<PD1) | (1<<PD5) | (1<<PD6);
}

void init_allrow()
{
//set to HIGH
	//PORTC |= (1<<PC0) | (1<<PC1) | (1<<PC2) | (1<<PC3);
	PORTC &= ~(1<<PC0) & ~(1<<PC1) & ~(1<<PC2) & ~(1<<PC3);
	PORTC |= (1<<PC0);
}

void init_row1(uint8_t n)
{
	PORTC &= ~(1<<PC0) & ~(1<<PC1) & ~(1<<PC2) & ~(1<<PC3) & ~(1<<PC4) & ~(1<<PC5);
	PORTB &= ~(1<<PB4) & ~(1<<PB5);
	if(n == 0) PORTC |= (1<<PC2);
	else if(n == 1) PORTC |= (1<<PC3);
	else if(n == 2) PORTC |= (1<<PC4);
	else if(n == 3) PORTC |= (1<<PC5);
}
uint8_t ifKeyPressed1(uint8_t row,uint8_t col)
{
    uint8_t box;
    init_row1(row);
    if(col == 0)box = IS1_COL0_PRESSED();
	else if(col == 1)box = IS1_COL1_PRESSED();
	else if(col == 2)box = IS1_COL2_PRESSED();
	else if(col == 3)box = IS1_COL3_PRESSED();
	return box;
}
uint8_t getKeyMatrix1(uint8_t row,uint8_t col)
{
    uint8_t board1[4];
    uint8_t i;
    uint8_t count = 0;
    
    for (i=0;i<4;i++)
    {
        board1[i] = ifKeyPressed1(i,col);
        if(board1[i] > 0)
            count += 1;
    }
    
    if(count)
    {
        for(i=0;i<4;i++)
        {
            if(board1[i])
                board1[i]=0;
            else
                board1[i]=1;
        }
    }
    
    
    return board1[row];
}




void init_row2(uint8_t n)
{
	PORTC &= ~(1<<PC0) & ~(1<<PC1) & ~(1<<PC2) & ~(1<<PC3) & ~(1<<PC4) & ~(1<<PC5);
	PORTB &= ~(1<<PB4) & ~(1<<PB5);
	if(n == 0) PORTC |= (1<<PC0);
	else if(n == 1) PORTC |= (1<<PC1);
	else if(n == 2) PORTB |= (1<<PB4);
	else if(n == 3) PORTB |= (1<<PB5);
}
uint8_t ifKeyPressed2(uint8_t row,uint8_t col)
{
    uint8_t box;
    init_row2(row);
    if(col == 0)box = IS2_COL0_PRESSED();
	else if(col == 1)box = IS2_COL1_PRESSED();
	else if(col == 2)box = IS2_COL2_PRESSED();
	else if(col == 3)box = IS2_COL3_PRESSED();
	return box;
}
uint8_t getKeyMatrix2(uint8_t row,uint8_t col)
{
    uint8_t board2[4];
    uint8_t i;
    uint8_t count = 0;
    
    for (i=0;i<4;i++)
    {
        board2[i] = ifKeyPressed2(i,col);
        if(board2[i] > 0)
            count += 1;
    }
    
    if(count)
    {
        for(i=0;i<4;i++)
        {
            if(board2[i])
                board2[i]=0;
            else
                board2[i]=1;
        }
    }
    
    
    return board2[row];
}
