package com.mygdx.game;

import com.badlogic.gdx.Gdx;
import com.badlogic.gdx.Input;
import com.badlogic.gdx.audio.Sound;
import com.badlogic.gdx.utils.Timer;
import com.badlogic.gdx.utils.Timer.Task;

import java.util.Random;

import org.usb4java.Device;

public class World {
    private QuickAttacker quickAttacker;
    private BlackBlock blackBlock;
    Random rand = new Random();
    int[] numBlock = new int[4];
    int[] numSword = new int[6];
    int[] numDefense = new int[2];
    boolean[] sword;
    boolean[] defense;
    
    boolean[]keyPressed1 = new boolean[16];
    boolean[]keyPressed2 = new boolean[16];
    boolean[] player1;
    boolean[] player2;
    
    int screenTimer = 0;////delay at each screen
    int screenTime = 120;
    
    int timePlayer1;
    int timePlayer2;
    
    int gameStage = 0;
    
    int scorePlayer1 = 0;
    int scorePlayer2 = 0;
    Sound bg = Gdx.audio.newSound(Gdx.files.internal("theme.wav"));
    Sound attack = Gdx.audio.newSound(Gdx.files.internal("win.wav"));
    Sound block = Gdx.audio.newSound(Gdx.files.internal("block.wav"));
    Sound win = Gdx.audio.newSound(Gdx.files.internal("win.wav"));
    
    private McuWithPeriBoard peri;
    
    public World(QuickAttacker quickAttacker){
        this.quickAttacker = quickAttacker;
        //bg.dispose();
        long id = bg.play(1.0f); 
        bg.setLooping(id, true);
        blackBlock = new BlackBlock(quickAttacker);
        do {
            numBlock = getRandom(numBlock);
        } while(checkArray(numBlock) == false);
        player1 = setButton(numBlock);
        player2 = setButton(numBlock);
        do {
            do {
                numSword = getRandom(numSword);
            } while(checkArray(numSword) == false);
            do {
                numDefense = getRandom(numDefense);
            } while(checkArray(numDefense) == false);
        } while(checkArray2(numDefense,numSword) == false);
        sword = setButton(numSword);
        defense = setButton(numDefense);
        
        McuBoard.initUsb();

        try
        {
        	Device[] devices = McuBoard.findBoards();
        	
        	if (devices.length == 0) {
                System.out.format("** Practicum board not found **\n");
                return;
        	}
        	else {
                System.out.format("** Found %d practicum board(s) **\n", devices.length);
        	}
            peri = new McuWithPeriBoard(devices[0]);

            System.out.format("** Practicum board found **\n");
            System.out.format("** Manufacturer: %s\n", peri.getManufacturer());
            System.out.format("** Product: %s\n", peri.getProduct());
            
        }
        catch (Exception e)
        {
            System.out.println(e);
        }
    }
    
    public void render(){
        if(gameStage==1) {
            int time1 = player1Stage(player1,numBlock);
            int time2 = player2Stage(player2,numBlock);
            if(time1!=0 && time2!=0)
            {
            	screenTimer++;
            	if(screenTimer > rand.nextInt(10)+50)
            	{
            		screenTimer = 0;
            		compare(time1, time2);
            	}
            }
        }
        if(gameStage==2) 
        {
            int atime1 = player1Stage(sword,numSword);
            int atime2 = player2Stage(defense,numDefense);
            if(atime1>atime2) 
            {
                System.out.println("Attack Success!!");
                this.scorePlayer1++;
                gameStage=-4;
                attack.play();
            }
               
            if(atime1<atime2) {
                System.out.println("Attack fail!!");
                gameStage=-6;
                block.play(2.0f);
            }
        }
        if(gameStage==3) {
            int btime1 = player1Stage(defense,numDefense);
            int btime2 = player2Stage(sword,numSword);
            if(btime1>btime2) {
                System.out.println("Attack fail!!");
                gameStage=-6;
                block.play();
            }
            if(btime1<btime2) {
                System.out.println("Attack Success!!");
                this.scorePlayer2++;
                gameStage=-5;
                attack.play(2.0f);
            }
        }
        if(gameStage == 0)
        {
        	/////////////check winner
        	if(this.scorePlayer1 > 2 || this.scorePlayer2 > 2)
        	{
        		gameStage = -7;
        	}
        	else{
        	/////////////
            do {
                numBlock = getRandom(numBlock);
            } while(checkArray(numBlock) == false);
            player1 = setButton(numBlock);
            player2 = setButton(numBlock);
            do {
                do {
                    numSword = getRandom(numSword);
                } while(checkArray(numSword) == false);
                do {
                    numDefense = getRandom(numDefense);
                } while(checkArray(numDefense) == false);
            } while(checkArray2(numDefense,numSword) == false);
            sword = setButton(numSword);
            defense = setButton(numDefense);
        	gameStage =-3;
        	}
        }
        //////////////////splash screens///////////////////
        if(gameStage == -10)//TUTORIAL
        {
        	if(Gdx.input.isKeyPressed(Input.Keys.R) || peri.getSwitch1(3,3))
        	{
                if (!keyPressed1[15]) 
                {
                       keyPressed1[15] = true;
                       gameStage--;
                }
            } 
        	else 
            {
        		keyPressed1[15] = false;
            }
        	if(Gdx.input.isKeyPressed(Input.Keys.Q) || gameStage <= -16 || peri.getSwitch1(3,0))
        	{
                if (!keyPressed1[12]) 
                {
                       keyPressed1[12] = true;
                       gameStage = 0;
                }
            } 
        	else 
            {
        		keyPressed1[12] = false;
            }
        }
        if(gameStage == -3)//before prepare
        {
        	screenTimer++;
        	if(screenTimer > screenTime+rand.nextInt(70)+0)
        	{
        		screenTimer = 0;
        		gameStage = 1;
        	}
        }
        if(gameStage == -1)//before P1 attack
        {
        	screenTimer++;
        	if(screenTimer > screenTime+rand.nextInt(70)+0)
        	{
        		screenTimer = 0;
        		gameStage = 2;
        	}
        }
        if(gameStage == -2)//before P2 attack
        {
        	screenTimer++;
        	if(screenTimer > screenTime+rand.nextInt(70)+0)
        	{
        		screenTimer = 0;
        		gameStage = 3;
        	}
        }
        if(gameStage == -4)//P1 scored
        {
        	screenTimer++;
        	if(screenTimer > screenTime)
        	{
        		screenTimer = 0;
        		gameStage = 0;
        	}
        }
        if(gameStage == -5)//P2 scored
        {
        	screenTimer++;
        	if(screenTimer > screenTime)
        	{
        		screenTimer = 0;
        		gameStage = 0;
        	}
        }
        if(gameStage == -6)//attack blocked
        {
        	screenTimer++;
        	if(screenTimer > screenTime)
        	{
        		screenTimer = 0;
        		gameStage = 0;
        	}
        }
        if(gameStage == -7)//END SCREEN
        {
        	screenTimer++;
        	if(screenTimer > 150)
        	{
        		scorePlayer1 = 0;
        		scorePlayer2 = 0;
        		screenTimer = 0;
        		gameStage = 0;
                win.play();
        		
        	}
        }
        ////////////////////////////////////////////////
    }
    
    public int player1Stage(boolean[] player1, int[] num){
        if(!checkPass(player1,num)){
            timePlayer1 += 1;
            if(Gdx.input.isKeyPressed(Input.Keys.Q) || peri.getSwitch1(0,0)){
            	if (!keyPressed1[0]) 
            	{
                    keyPressed1[0] = true;
                    player1[0]=true;
                } 
            } 
            else 
            {
                keyPressed1[0] = false;
            }
            if(Gdx.input.isKeyPressed(Input.Keys.W) || peri.getSwitch1(0,1)){
            	if (!keyPressed1[1]) 
            	{
                    keyPressed1[1] = true;
                    player1[1]=true;
                }
            } 
            else 
            {
                keyPressed1[1] = false;
            }
            if(Gdx.input.isKeyPressed(Input.Keys.E) || peri.getSwitch1(0,2)){
             	if (!keyPressed1[2]) 
            	{
                    keyPressed1[2] = true;
                    player1[2]=true;
                }
            } 
            else 
            {
                keyPressed1[2] = false;
            }
            if(Gdx.input.isKeyPressed(Input.Keys.R) || peri.getSwitch1(0,3)){
             	if (!keyPressed1[3]) 
            	{
                    keyPressed1[3] = true;
                    player1[3]=true;
                }
            } 
            else 
            {
                keyPressed1[3] = false;
            }
            if(Gdx.input.isKeyPressed(Input.Keys.Q) || peri.getSwitch1(1,0)){
             	if (!keyPressed1[4]) 
            	{
                    keyPressed1[4] = true;
                    player1[4]=true;
                }
            } 
            else 
            {
                keyPressed1[4] = false;
            }
            if(Gdx.input.isKeyPressed(Input.Keys.W) || peri.getSwitch1(1,1)){
             	if (!keyPressed1[5]) 
            	{
                    keyPressed1[5] = true;
                    player1[5]=true;
                }
            } 
            else 
            {
                keyPressed1[5] = false;
            }
            if(Gdx.input.isKeyPressed(Input.Keys.E) || peri.getSwitch1(1,2)){
             	if (!keyPressed1[6]) 
            	{
                    keyPressed1[6] = true;
                    player1[6]=true;
                }
            } 
            else 
            {
                keyPressed1[6] = false;
            }
            if(Gdx.input.isKeyPressed(Input.Keys.R) || peri.getSwitch1(1,3)){
             	if (!keyPressed1[7]) 
            	{
                    keyPressed1[7] = true;
                    player1[7]=true;
                }
            } 
            else 
            {
                keyPressed1[7] = false;
            }
            if(Gdx.input.isKeyPressed(Input.Keys.Q) || peri.getSwitch1(2,0)){
             	if (!keyPressed1[8]) 
            	{
                    keyPressed1[8] = true;
                    player1[8]=true;
                }
            } 
            else 
            {
                keyPressed1[8] = false;
            }
            if(Gdx.input.isKeyPressed(Input.Keys.W) || peri.getSwitch1(2,1)){
             	if (!keyPressed1[9]) 
            	{
                    keyPressed1[9] = true;
                    player1[9]=true;
                }
            } 
            else 
            {
                keyPressed1[9] = false;
            }
            if(Gdx.input.isKeyPressed(Input.Keys.E) || peri.getSwitch1(2,2)){
             	if (!keyPressed1[10]) 
            	{
                    keyPressed1[10] = true;
                    player1[10]=true;
                }
            } 
            else 
            {
                keyPressed1[10] = false;
            }
            if(Gdx.input.isKeyPressed(Input.Keys.R) || peri.getSwitch1(2,3)){
             	if (!keyPressed1[11]) 
            	{
                    keyPressed1[11] = true;
                    player1[11]=true;
                }
            } 
            else 
            {
                keyPressed1[11] = false;
            }
            if(Gdx.input.isKeyPressed(Input.Keys.Q) || peri.getSwitch1(3,0)){
             	if (!keyPressed1[12]) 
            	{
                    keyPressed1[12] = true;
                    player1[12]=true;
                }
            } 
            else 
            {
                keyPressed1[12] = false;
            }
            if(Gdx.input.isKeyPressed(Input.Keys.W) || peri.getSwitch1(3,1)){
             	if (!keyPressed1[13]) 
            	{
                    keyPressed1[13] = true;
                    player1[13]=true;
                }
            } 
            else 
            {
                keyPressed1[13] = false;
            }
            if(Gdx.input.isKeyPressed(Input.Keys.E) || peri.getSwitch1(3,2)){
             	if (!keyPressed1[14]) 
            	{
                    keyPressed1[14] = true;
                    player1[14]=true;
                }
            } 
            else 
            {
                keyPressed1[14] = false;
            }
            if(Gdx.input.isKeyPressed(Input.Keys.R) || peri.getSwitch1(3,3)){
             	if (!keyPressed1[15]) 
            	{
                    keyPressed1[15] = true;
                    player1[15]=true;
                }
            } 
            else 
            {
                keyPressed1[15] = false;
            }
        }
        else {
            timePlayer1 += 0;
            return timePlayer1;
        }
        return 0;
    }
    
     public int player2Stage(boolean[] player2, int[] num){ 
        if(!checkPass(player2,num)){
            timePlayer2 += 1;
            if(Gdx.input.isKeyPressed(Input.Keys.A) || peri.getSwitch2(0,0)){
            	if (!keyPressed2[0]) 
            	{
                    keyPressed2[0] = true;
                    player2[0]=true;
                }
            } 
            else 
            {
                keyPressed2[0] = false;
            }
            if(Gdx.input.isKeyPressed(Input.Keys.S) || peri.getSwitch2(0,1)){
            	if (!keyPressed2[1]) 
            	{
                    keyPressed2[1] = true;
                    player2[1]=true;
                }
            } 
            else 
            {
                keyPressed2[1] = false;
            }
            if(Gdx.input.isKeyPressed(Input.Keys.D) || peri.getSwitch2(0,2)){
            	if (!keyPressed2[2]) 
            	{
                    keyPressed2[2] = true;
                    player2[2]=true;
                }
            } 
            else 
            {
                keyPressed2[2] = false;
            }
            if(Gdx.input.isKeyPressed(Input.Keys.F) || peri.getSwitch2(0,3)){
            	if (!keyPressed2[3]) 
            	{
                    keyPressed2[3] = true;
                    player2[3]=true;
                }
            } 
            else 
            {
                keyPressed2[3] = false;
            }
            if(Gdx.input.isKeyPressed(Input.Keys.A) || peri.getSwitch2(1,0)){
            	if (!keyPressed2[4]) 
            	{
                    keyPressed2[4] = true;
                    player2[4]=true;
                }
            } 
            else 
            {
                keyPressed2[4] = false;
            }
            if(Gdx.input.isKeyPressed(Input.Keys.S) || peri.getSwitch2(1,1)){
            	if (!keyPressed2[5]) 
            	{
                    keyPressed2[5] = true;
                    player2[5]=true;
                }
            } 
            else 
            {
                keyPressed2[5] = false;
            } 
            if(Gdx.input.isKeyPressed(Input.Keys.D) || peri.getSwitch2(1,2)){
            	if (!keyPressed2[6]) 
            	{
                    keyPressed2[6] = true;
                    player2[6]=true;
                }
            } 
            else 
            {
                keyPressed2[6] = false;
            } 
            if(Gdx.input.isKeyPressed(Input.Keys.F) || peri.getSwitch2(1,3)){
            	if (!keyPressed2[7]) 
            	{
                    keyPressed2[7] = true;
                    player2[7]=true;
                }
            } 
            else 
            {
                keyPressed2[7] = false;
            }
            if(Gdx.input.isKeyPressed(Input.Keys.A) || peri.getSwitch2(2,0)){
            	if (!keyPressed2[8]) 
            	{
                    keyPressed2[8] = true;
                    player2[8]=true;
                }
            } 
            else 
            {
                keyPressed2[8] = false;
            }
            if(Gdx.input.isKeyPressed(Input.Keys.S) || peri.getSwitch2(2,1)){
            	if (!keyPressed2[9]) 
            	{
                    keyPressed2[9] = true;
                    player2[9]=true;
                }
            } 
            else 
            {
                keyPressed2[9] = false;
            } 
            if(Gdx.input.isKeyPressed(Input.Keys.D) || peri.getSwitch2(2,2)){
            	if (!keyPressed2[10]) 
            	{
                    keyPressed2[10] = true;
                    player2[10]=true;
                }
            } 
            else 
            {
                keyPressed2[10] = false;
            } 
            if(Gdx.input.isKeyPressed(Input.Keys.F) || peri.getSwitch2(2,3)){
            	if (!keyPressed2[11]) 
            	{
                    keyPressed2[11] = true;
                    player2[11]=true;
                }
            } 
            else 
            {
                keyPressed2[11] = false;
            }
            if(Gdx.input.isKeyPressed(Input.Keys.A) || peri.getSwitch2(3,0)){
            	if (!keyPressed2[12]) 
            	{
                    keyPressed2[12] = true;
                    player2[12]=true;
                }
            } 
            else 
            {
                keyPressed2[12] = false;
            }
            if(Gdx.input.isKeyPressed(Input.Keys.S) || peri.getSwitch2(3,1)){
            	if (!keyPressed2[13]) 
            	{
                    keyPressed2[13] = true;
                    player2[13]=true;
                }
            } 
            else 
            {
                keyPressed2[13] = false;
            } 
            if(Gdx.input.isKeyPressed(Input.Keys.D) || peri.getSwitch2(3,2)){
            	if (!keyPressed2[14]) 
            	{
                    keyPressed2[14] = true;
                    player2[14]=true;
                }
            } 
            else 
            {
                keyPressed2[14] = false;
            } 
            if(Gdx.input.isKeyPressed(Input.Keys.F) || peri.getSwitch2(3,3)){
            	if (!keyPressed2[15]) 
            	{
                    keyPressed2[15] = true;
                    player2[15]=true;
                }
            } 
            else 
            {
                keyPressed2[15] = false;
            }
        }
        else{
            timePlayer2 += 0;
            return timePlayer2;
        }
        return 0;
    }
     
    public void compare(int time1, int time2) {
        if (time1<time2) {
            System.out.println("Player1 Win!!!");
            gameStage = -1;
            System.out.println(gameStage);
        } else if (time2<time1) {
            System.out.println("Player2 Win!!!");
            gameStage = -2;
            System.out.println(gameStage);
        } else if (time1==time2) {
            System.out.println("Draw");
            gameStage = -3;
            System.out.println(gameStage);
        }
        timePlayer1 =0;
        timePlayer2 =0;
    }
    
    public boolean checkPass(boolean[] arr,int[] num){
        int count = 0;
        if(gameStage==1) {
            for(int i=0 ; i<arr.length; i++){
                if(arr[i]==false)
                    return false;
            }
        }
        else {
            for(int i=0 ; i<arr.length; i++){
                if(arr[i]==false) {
                    count++;
                }
            }
            if(count==num.length)
                return false;
            return true;
        }
        return true;
    }
    
    public boolean[] setButton(int[] pos){
        boolean[] bool = new boolean[16];
        for(int j=0; j<bool.length; j++) {
                bool[j] = true;
        }
        for(int i=0; i<pos.length ; i++){
            for(int j=0; j<bool.length; j++) {
                if(pos[i]==j)
                    bool[j] = false;
            }
        }
        return bool;
    }
    
    public int[] getRandom(int[] arr){
        for(int i=0; i<arr.length ; i++){
            arr[i] = rand.nextInt(15)+0;
        }
        return arr;
    }
    
    public boolean checkArray(int[] arr){
        for(int i=0; i<arr.length-1 ; i++){
            for(int j=i+1 ; j<arr.length ; j++){
                if(arr[i] == arr[j]){
                    return false;
                }
            }
        }
        return true;
    }
    
    public boolean checkArray2(int[] arr1,int[] arr2){
        for(int i=0; i<arr1.length ; i++){
            for(int j=0 ; j<arr2.length ; j++){
                if(arr1[i] == arr2[j]){
                    return false;
                }
            }
        }
        return true;
    }
    
    //////
    public void resetKey(boolean[] arr)
    {
    	for(int i=0; i<arr.length ; i++){
            arr[i] = false;
        }
    }
    //////
    
    
    public int[] getPositionXBlock(){
        return blackBlock.getPositionXBlock(numBlock);
    }
    
    public int[] getPositionYBlock(){
        return blackBlock.getPositionYBlock(numBlock);
    }
    
    public int[] getPositionSwordX(){
        return blackBlock.getPositionXBlock(numSword);
    }
    
    public int[] getPositionSwordY(){
        return blackBlock.getPositionYBlock(numSword);
    }
    public int[] getPositionDefenseX(){
        return blackBlock.getPositionXBlock(numDefense);
    }
    
    public int[] getPositionDefenseY(){
        return blackBlock.getPositionYBlock(numDefense);
    }
    
    public boolean[] getPlayer1(){
        return player1;
    }
    
    public boolean[] getPlayer2(){
        return player2;
    }
    
    public int getGameStage() {
        return gameStage;
    }
    
    public int getScorePlayer1() {
        return scorePlayer1;
    }
    
    public int getScorePlayer2() {
        return scorePlayer2;
    }
}
